//     ------------------------------------------------
DWORD CreateWindow(void)  //Create a window and return hWnd
struct WNDCLASSEX wc;
dword WND;
{


        hInst=GetModuleHandleA(0);
        wc.cbSize=sizeof(wc);
        wc.style= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
//CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
        wc.lpfnWndProc=#WndProc;
        wc.cbWndExtra=NULL;
        wc.cbClsExtra=NULL;
        wc.hInstance=hInst;
        wc.hIcon=LoadIconA(hInst, IDI_ICON1);
        wc.hCursor=LoadCursor(NULL,IDC_ARROW);
        wc.hbrBackground=COLOR_WINDOW;      //COLOR_GRAYTEXT;
        wc.lpszMenuName=MyMenu;          //    0;
        wc.lpszClassName=#classTitle;
        wc.hIconSm=0;
        RegisterClassExA(#wc);         //  

        hMenu=LoadMenuA(hInst,MyMenu); //    
                           //   

        WND=CreateWindowExA(0,
                            #classTitle,
                            #WindowTitle,
                WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN|WS_CLIPSIBLINGS,  
		CW_USEDEFAULT, CW_USEDEFAULT,
                _Width_SCR_, _Height_SCR_,
                            0,
                            hMenu,
                            hInst,
                            0);

//WS_OVERLAPPED        -    ,    
//                         .
//WS_POPUP             -    ,   
//WS_OVERLAPPEDWINDOWS -     



//         
//  
//        ShowWindow(EAX,SW_SHOWNORMAL); //show window
//        UpdateWindow(EAX);             //redraw window

        return WND;
}
	       		

//Windows 
dword   WndProc(dword hWnd,msg,wPar,lPar) 
{

        switch(msg){


             	case WM_PAINT: 

             	     Flip(hWnd);        //  md2
                     $xor eax, eax
                    break;



               case WM_SIZE:


	       GetClientRect(hWnd,#rcGL); 
	       glViewport(0,0,rcGL.right,rcGL.bottom);
	       InvalidateRect(hWnd,NULL,FALSE);
	       $xor eax,eax
               break;

//----------------------------------------------------------------------------
		case WM_COMMAND:         //    
			switch(wPar)
                        {


			         case IDM_WWW_SITE:


		ShellExecute(hWnd,0,#site,0,"vov.ru",SW_SHOWNORMAL);
		ShowWindow(hWnd, SW_SHOWNOACTIVATE);

                                        EAX=0;
					break;


				default:
					SendMessageA(hWnd,WM_CLOSE,0,0);
                                        EAX=0;					
                                        break;



			}
			EAX=0;
			break;
//---------------------------------------------------------------------------



    case WM_KEYDOWN:
    
      switch(wPar)
      {
        // wParam     Escape ?
        case VK_ESCAPE:
          //  - "" .    Escape,
          //       WM_CLOSE - 
          //   .    -
          //  wParam  lParam   .
          SendMessage(hWnd,WM_CLOSE,0,0);
          //   ,     ( 
          //   ,   ) 
          //  0     
          EAX=0;
          break;
      }


      // ,    -    ,
      //    ,  ,   ,   
      //   DefWindowProc() (. ).     !!!
      break;

               case WM_DESTROY:

		wglMakeCurrent( hdc, NULL );
		wglDeleteContext( hrc );

                        PostQuitMessage(0);
                        EAX=0;
                        BREAK;


                default:
                        DefWindowProcA(hWnd,msg,wPar,lPar);

        }


}


//    
//,      400x400
//       
//  , .
//         
//  
//  ,       
// WS_POPUP       
//  
BOOL SizeMoveWindow(DWORD hWnd)
{
DWORD xpos=0;
DWORD ypos=0;



//   
AdjustWindowRectEx(#window_rect,                       //  
                    GetWindowLong(hWnd, GWL_STYLE),    // 
                    GetMenu(hWnd),                     //  
                    GetWindowLong(hWnd, GWL_EXSTYLE)); // 


WidthClientWin=window_rect.right-window_rect.left; //
HeightClientWin=window_rect.bottom-window_rect.top; //

WidthClientWin=WidthClientWin-_Width_SCR_;
HeightClientWin=HeightClientWin-_Height_SCR_;

xpos=GetSystemMetrics(SM_CXSCREEN);
xpos-=_Width_SCR_;
xpos=xpos>>1;

ypos=GetSystemMetrics(SM_CYSCREEN);
ypos-=_Height_SCR_;
ypos=ypos>>1;



MoveWindow(hWnd, 
           xpos,       //CW_USEDEFAULT,                      //  
           ypos,       //CW_USEDEFAULT,                      //  
           window_rect.right-window_rect.left, //
           window_rect.bottom-window_rect.top, //
           FALSE);


        ShowWindow(hWnd,SW_SHOWNORMAL);   //show window
//        UpdateWindow(hWnd);             //redraw window
//        SetFocus(hWnd);


RETURN TRUE;
}





// OpenGL
BOOLEAN InitGL()
{


IF (hWnd==0) return FALSE;
hdc=GetDC(hWnd);
ZeroMemory(#pfd,sizeof(PIXELFORMATDESCRIPTOR)); 
pfd.nSize=sizeof(PIXELFORMATDESCRIPTOR);
pfd.nVersion=1;
pfd.dwFlags=PFD_SUPPORT_OPENGL+PFD_DOUBLEBUFFER+PFD_DRAW_TO_WINDOW;
pfd.dwLayerMask=PFD_MAIN_PLANE;
pfd.iPixelType=PFD_TYPE_RGBA;
pfd.cColorBits=32;   //24 ;16
pfd.cDepthBits=32;   //;32 ;16
pfd.cAccumBits=0;
pfd.cStencilBits=0;
ChoosePixelFormat(hdc,#pfd);
SetPixelFormat(hdc,EAX,#pfd);
hrc=wglCreateContext(hdc);
wglMakeCurrent(hdc,hrc);



//    :
// Viewport  OpenGL
GetClientRect(hWnd,#rcGL);
glViewport(0,0,rcGL.right,rcGL.bottom);


//Z Buffer
//  z-:
glEnable(GL_DEPTH_TEST);
glDepthFunc(GL_LESS);
glClearDepth(lo_d(float 1.0),hi_d(float 1.0)); 


//Back color
// ,    GL_COLOR_BUFFER_BIT
//  glClear(GL_COLOR_BUFFER_BIT)
//glClearColor(0.0f, 0.0f, 0.5f, 1.0f);
glClearColor(0.0f, 0.0f, 0.0f, 0.0f);


//  2D 
glEnable(GL_TEXTURE_2D);





glMatrixMode(GL_PROJECTION);
//   
glLoadIdentity();



/*
//gluPerspective(45.0f,(GLfloat) width / (GLfloat) height, 0.1f, 5000.0f);

//	float	aspectratio = (float)width / (float)height;
//640/480 =1.333333333333
  gluPerspective(lo_d(float 45.0),hi_d(float 45.0),
                 lo_d(float 1.33), hi_d(float 1.33),
                 lo_d(float 0.2), hi_d(float 0.2),
                 lo_d(float 500.0), hi_d(float 500.0));

glTranslatef (0.0f, 0.0f, -5.0f); //  -  Z 
*/



	 

glMatrixMode(GL_MODELVIEW);
glLoadIdentity();



}



// FPS
byte StringFPS[255];
dword FPS;
dword LastTime;


ViewFPS(dword hWnd_handle)
{
	$push EBX
	EBX=EAX=GetTickCount();
//	IF(LastTime==0)LastTime=EAX;
	FPS++;
	IF(EAX-LastTime>=1000){
		LastTime=EBX;
		wsprintfA(#StringFPS,#fpsview,FPS);

//  		wsprintfA(#mapstr,"%d fps",FPS);

//		SetWindowText(hWnd_handle,#StringFPS);
		FPS=0;
	}
	$pop EBX

}

